module XmtFroala
  class InstallGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    desc "Install xmt_froala for your application."

    def copy_kindeditor_files
      if ::Rails.version < "3.1.0"
        warn "Warning: xmt_froala ~> v0.3.0 only support Rails3.1+!"
        warn "If you're using rails3.0.x, please check xmt_froala v0.2.8"
      else
        template "xmt_froala.rb", "config/initializers/xmt_froala.rb"
      end
    end
    
    def insert_or_copy_js_files
      if File.exist?('app/assets/javascripts/application.js')
        insert_into_file "app/assets/javascripts/application.js", "//= require xmt_froala\n", :after => "jquery_ujs\n"
      else
        copy_file "application.js", "app/assets/javascripts/application.js"
      end
    end
  end
end