require "xmt_froala"
require "rails"
require "action_controller"
module XmtFroala
  class Engine < ::Rails::Engine

    initializer "xmt_froala.assets_precompile" do |app|
      app.config.assets.precompile += XmtFroala.assets
    end

    initializer "xmt_froala.simple_form_and_formtastic" do
      require "xmt_froala/simple_form" if Object.const_defined?("SimpleForm")
      require "xmt_froala/formtastic" if Object.const_defined?("Formtastic")
    end

    initializer "xmt_froala.helper_and_builder" do
      ActiveSupport.on_load :action_view do
        ActionView::Base.send(:include, XmtFroala::Helper)
        ActionView::Helpers::FormBuilder.send(:include, XmtFroala::Builder)
      end
    end

    initializer "xmt_froala.image_process" do
      unless XmtFroala.image_resize_to_limit.nil?
        XmtFroala::ImageUploader.class_eval do
          include CarrierWave::MiniMagick
          process :resize_to_limit => XmtFroala.resize_to_limit
        end
      end
    end
  end
end
