/*!
 * froala_editor v2.8.1 (https://www.froala.com/wysiwyg-editor)
 * License https://froala.com/wysiwyg-editor/terms/
 * Copyright 2014-2018 Froala Labs
 */

(function (factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(['jquery'], factory);
    } else if (typeof module === 'object' && module.exports) {
        // Node/CommonJS
        module.exports = function( root, jQuery ) {
            if ( jQuery === undefined ) {
                // require('jQuery') returns a factory that requires window to
                // build a jQuery instance, we normalize how we use modules
                // that require this pattern but the window provided is a noop
                // if it's defined (how jquery works)
                if ( typeof window !== 'undefined' ) {
                    jQuery = require('jquery');
                }
                else {
                    jQuery = require('jquery')(root);
                }
            }
            return factory(jQuery);
        };
    } else {
        // Browser globals
        factory(window.jQuery);
    }
}(function ($) {

    $.FE.PLUGINS.plainPaste = function (editor) {

        function show () {
               var html_overlay = '<div class="ke-overlay"></div>';
               var html_text_header = '<div class="ke-text-hrader"><span class="ke-text-left">文本无格式粘贴</span><span class="ke-text-right"><i class="fa fa-times ke-remove fa-1x" aria-hidden="true"></i></span></div>';
               var html_text_content = '<div class="ke-text-content"><textarea class="ke-text-textarea"></textarea></div>';
               var html_text_footer = '<div  class="ke-text-footer"><button class="ke-remove remove">取消</button><button class="ke-submit submit">确认</button></div>';
               var html_text = '<div class="html_text">'+html_text_header+html_text_content+html_text_footer+'</div>';
               $("body").append(html_overlay+html_text);
               _hide();
               _pasteText()
        }

        /*
         * Hide the image manager.
         */
        function _hide () {
           $(".ke-remove").click(function () {
               $(".ke-overlay").remove();
               $(".html_text").remove();
           });
        }

        function _pasteText(){
            $(".ke-submit").click(function () {
                var Text = $(".ke-text-textarea").val();
                html = _escape(Text);
                html = html.replace(/ {2}/g, ' &nbsp;');
                html = html.replace(/^/, '<p>').replace(/$/, '</p>').replace(/\n/g, '</p><p>');
                editor.html.insert(html);
                $(".ke-overlay").remove();
                $(".html_text").remove();
            });
        }

        function _escape(val) {
            return val.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
        }

        return {
            require: ['text'],
            show: show,
            hide: _hide
        }
    };

    $.FE.RegisterCommand('plainPaste', {
        title: 'Clipboard',
        undo: false,
        focus: false,
        modal: true,
        callback: function () {
            this.plainPaste.show();
        },
        plugin: 'plainPaste'
    })

    // Add the font size icon.
    $.FE.DefineIcon('plainPaste', {
        NAME: 'clipboard'
    });

}));
