/*!
 * froala_editor v2.8.1 (https://www.froala.com/wysiwyg-editor)
 * License https://froala.com/wysiwyg-editor/terms/
 * Copyright 2014-2018 Froala Labs
 */

(function (factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(['jquery'], factory);
    } else if (typeof module === 'object' && module.exports) {
        // Node/CommonJS
        module.exports = function( root, jQuery ) {
            if ( jQuery === undefined ) {
                // require('jQuery') returns a factory that requires window to
                // build a jQuery instance, we normalize how we use modules
                // that require this pattern but the window provided is a noop
                // if it's defined (how jquery works)
                if ( typeof window !== 'undefined' ) {
                    jQuery = require('jquery');
                }
                else {
                    jQuery = require('jquery')(root);
                }
            }
            return factory(jQuery);
        };
    } else {
        // Browser globals
        factory(window.jQuery);
    }
}(function ($) {

    $.FE.PLUGINS.quickFormat = function (editor) {

        function show () {
            var html = editor.html.get();
           var result=html.replace(/style="[^"]+"/ig,"");//把'is'替换为空字符串
            result=result.replace(/<p><br><\/p>/ig,"");//把'is'替换为空字符串
            result=result.replace(/<p ><br><\/p>/ig,"");//把'is'替换为空字符串

            var html_arr = result.split("</p><p>");
            var html_text='';
            for(var i=0;i< html_arr.length;i++){
                if (i==0){
                        var text = html_arr[0].replace('<p>',"");
                        html_text += '<p style="text-indent:2em;">'+text+'</p>';
                }else if(i==html_arr.length-1){
                    var text_ = html_arr[i].replace('</p>',"");
                    html_text += '<p style="text-indent:2em;">'+text_+'</p>';
                }else if(html_arr[i].indexOf("img") > 0 ){
                                html_text +='<p>'+html_arr[i]+'</p>';
                }else if(html_arr[i].indexOf("video") > 0 ){
                                html_text +='<p>'+html_arr[i]+'</p>';
                }else {
                        html_text += '<p style="text-indent:2em;">' + html_arr[i] + '</p>';
                }
            }

            if(html_text){
                editor.html.set('');
                editor.html.insert(html_text);
            }

        }

        return {
            require: ['text'],
            show: show,
        }
    };

    $.FE.RegisterCommand('quickFormat', {
        title: 'quickFormat',
        undo: false,
        focus: false,
        modal: true,
        callback: function () {
            this.quickFormat.show();
        },
        plugin: 'quickFormat'
    })

    // Add the font size icon.
    $.FE.DefineIcon('quickFormat', {
        NAME: 'pencil-square-o'
    });

}));
